/**
 * JavaScript for mboard plugin.
 */
var plugin_mboard = {
	submit : function(button) {
		var form = button.form;
		if (form.lock) return;
		form.lock = true;
		var data = '';
		var delm = '';
		this.params = {};
		for (var i = 0; i < form.elements.length; i++) {
			var e = form.elements[i];
			switch(e.nodeName.toLowerCase()) {
			case 'input':
				this.params[e.name] = e.value;
				data += delm + e.name + '=' + encodeURI(e.value);
				break;
			case 'textarea':
				this.params[e.name] = e.value;
				data += delm + e.name + '=' + encodeURI(e.value).replace(/&/g, '%26');
				break;
			case 'select':
			default:
			}
			delm = '&';
		}
		var xmlhttp = this.xmlhttp = this.createhttp();
		var self = this;
		xmlhttp.open("POST", DOKU_BASE + 'lib/exe/ajax.php', true);
		xmlhttp.onreadystatechange = function() { self.onload.apply(self); };
		xmlhttp.send(data);
	},

	list : function(id, page) {
		this.params = {};
		this.params.id = id;
		this.params.page = page;
		var xmlhttp = this.xmlhttp = this.createhttp();
		var self = this;
		xmlhttp.open("POST", DOKU_BASE + 'lib/exe/ajax.php', true);
		xmlhttp.onreadystatechange = function() { self.onload.apply(self); };
		xmlhttp.send('call=mboard&id='+escape(id)+'&page='+page);
	},

	remove : function(id, num, page) {
		if (!confirm(LANG['del_confirm']))
			return;
		this.params = {};
		this.params.id = id;
		var xmlhttp = this.xmlhttp = this.createhttp();
		var self = this;
		xmlhttp.open("POST", DOKU_BASE + 'lib/exe/ajax.php', true);
		xmlhttp.onreadystatechange = function() { self.onload.apply(self); };
		xmlhttp.send('call=mboard&cmd=remove&id='+escape(id)+'&num='+num+'&page='+page);
	},

	createhttp : function() {
		var xmlhttp;
		try {
			xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (err) {
				xmlhttp = null;
			};
		};
		if(!xmlhttp && typeof XMLHttpRequest != "undefined"){
			xmlhttp = new XMLHttpRequest();
		}
		return xmlhttp;
	},

	onload : function() {
		if (this.xmlhttp.readyState != 4)
			return;
		if (this.xmlhttp.status != 200) {
			//TODO エラー時はフォームをunlockする
			alert(this.xmlhttp.responseText);
			return;
		}

		var nodeid = 'mboard__' + this.params.id.replace(/^.*#/, '').replace(/[^a-zA-Z]/g, '_');
		var target = document.getElementById(nodeid);
		if (target) {
			target.innerHTML = this.xmlhttp.responseText;
		}
	}
};
